/**
  * @module vue-mdc-adaptertexfield 0.4.2
  * @exports VueMDCTextfield
  * @copyright (c) 2017-present, Sebastien Tasson
  * @license https://opensource.org/licenses/MIT
  * @implements {"material-components-web":"0.25.0"}
  * @requires {"vue":"^2.5.6"}
  * @see https://github.com/stasson/vue-mdc-adapter
  */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCTextfield=t()}(this,function(){"use strict";var e=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},t=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),n=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},i=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},a=function(){function n(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,n),this.adapter_=t}return t(n,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),t(n,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),n}(),s=(function(){function n(){e(this,n)}t(n,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"addClassToLabel",value:function(e){}},{key:"removeClassFromLabel",value:function(e){}},{key:"setIconAttr",value:function(e,t){}},{key:"eventTargetHasClass",value:function(e,t){}},{key:"registerTextFieldInteractionHandler",value:function(e,t){}},{key:"deregisterTextFieldInteractionHandler",value:function(e,t){}},{key:"notifyIconAction",value:function(){}},{key:"addClassToBottomLine",value:function(e){}},{key:"removeClassFromBottomLine",value:function(e){}},{key:"addClassToHelptext",value:function(e){}},{key:"removeClassFromHelptext",value:function(e){}},{key:"helptextHasClass",value:function(e){}},{key:"registerInputInteractionHandler",value:function(e,t){}},{key:"deregisterInputInteractionHandler",value:function(e,t){}},{key:"registerTransitionEndHandler",value:function(e){}},{key:"deregisterTransitionEndHandler",value:function(e){}},{key:"setBottomLineAttr",value:function(e,t){}},{key:"setHelptextAttr",value:function(e,t){}},{key:"removeHelptextAttr",value:function(e){}},{key:"getNativeInput",value:function(){}}])}(),{ARIA_HIDDEN:"aria-hidden",ROLE:"role",INPUT_SELECTOR:".mdc-text-field__input",LABEL_SELECTOR:".mdc-text-field__label",ICON_SELECTOR:".mdc-text-field__icon",ICON_EVENT:"MDCTextField:icon",BOTTOM_LINE_SELECTOR:".mdc-text-field__bottom-line"}),r={ROOT:"mdc-text-field",UPGRADED:"mdc-text-field--upgraded",DISABLED:"mdc-text-field--disabled",FOCUSED:"mdc-text-field--focused",INVALID:"mdc-text-field--invalid",HELPTEXT_PERSISTENT:"mdc-text-field-helptext--persistent",HELPTEXT_VALIDATION_MSG:"mdc-text-field-helptext--validation-msg",LABEL_FLOAT_ABOVE:"mdc-text-field__label--float-above",LABEL_SHAKE:"mdc-text-field__label--shake",BOX:"mdc-text-field--box",TEXT_FIELD_ICON:"mdc-text-field__icon",TEXTAREA:"mdc-text-field--textarea",BOTTOM_LINE_ACTIVE:"mdc-text-field__bottom-line--active"},o=function(o){function l(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,l);var n=i(this,(l.__proto__||Object.getPrototypeOf(l)).call(this,Object.assign(l.defaultAdapter,t)));return n.isFocused_=!1,n.receivedUserInput_=!1,n.useCustomValidityChecking_=!1,n.inputFocusHandler_=function(){return n.activateFocus()},n.inputBlurHandler_=function(){return n.deactivateFocus()},n.inputInputHandler_=function(){return n.autoCompleteFocus()},n.setPointerXOffset_=function(e){return n.animateBottomLine(e)},n.textFieldInteractionHandler_=function(e){return n.handleTextFieldInteraction(e)},n.transitionEndHandler_=function(e){return n.handleBottomLineAnimationEnd(e)},n}return n(l,a),t(l,null,[{key:"cssClasses",get:function(){return r}},{key:"strings",get:function(){return s}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},addClassToLabel:function(){},removeClassFromLabel:function(){},setIconAttr:function(){},eventTargetHasClass:function(){},registerTextFieldInteractionHandler:function(){},deregisterTextFieldInteractionHandler:function(){},notifyIconAction:function(){},addClassToBottomLine:function(){},removeClassFromBottomLine:function(){},addClassToHelptext:function(){},removeClassFromHelptext:function(){},helptextHasClass:function(){return!1},registerInputInteractionHandler:function(){},deregisterInputInteractionHandler:function(){},registerTransitionEndHandler:function(){},deregisterTransitionEndHandler:function(){},setBottomLineAttr:function(){},setHelptextAttr:function(){},removeHelptextAttr:function(){},getNativeInput:function(){}}}}]),t(l,[{key:"init",value:function(){var e=this;this.adapter_.addClass(l.cssClasses.UPGRADED),this.getNativeInput_().value&&this.adapter_.addClassToLabel(l.cssClasses.LABEL_FLOAT_ABOVE),this.adapter_.registerInputInteractionHandler("focus",this.inputFocusHandler_),this.adapter_.registerInputInteractionHandler("blur",this.inputBlurHandler_),this.adapter_.registerInputInteractionHandler("input",this.inputInputHandler_),["mousedown","touchstart"].forEach(function(t){e.adapter_.registerInputInteractionHandler(t,e.setPointerXOffset_)}),["click","keydown"].forEach(function(t){e.adapter_.registerTextFieldInteractionHandler(t,e.textFieldInteractionHandler_)}),this.adapter_.registerTransitionEndHandler(this.transitionEndHandler_)}},{key:"destroy",value:function(){var e=this;this.adapter_.removeClass(l.cssClasses.UPGRADED),this.adapter_.deregisterInputInteractionHandler("focus",this.inputFocusHandler_),this.adapter_.deregisterInputInteractionHandler("blur",this.inputBlurHandler_),this.adapter_.deregisterInputInteractionHandler("input",this.inputInputHandler_),["mousedown","touchstart"].forEach(function(t){e.adapter_.deregisterInputInteractionHandler(t,e.setPointerXOffset_)}),["click","keydown"].forEach(function(t){e.adapter_.deregisterTextFieldInteractionHandler(t,e.textFieldInteractionHandler_)}),this.adapter_.deregisterTransitionEndHandler(this.transitionEndHandler_)}},{key:"handleTextFieldInteraction",value:function(e){if(!this.adapter_.getNativeInput().disabled){this.receivedUserInput_=!0;var t=e.target,n=e.type,i=l.cssClasses.TEXT_FIELD_ICON,a=this.adapter_.eventTargetHasClass(t,i),s="click"===n||"Enter"===e.key||13===e.keyCode;a&&s&&this.adapter_.notifyIconAction()}}},{key:"activateFocus",value:function(){var e=l.cssClasses,t=e.BOTTOM_LINE_ACTIVE,n=e.FOCUSED,i=e.LABEL_FLOAT_ABOVE,a=e.LABEL_SHAKE;this.adapter_.addClass(n),this.adapter_.addClassToBottomLine(t),this.adapter_.addClassToLabel(i),this.adapter_.removeClassFromLabel(a),this.showHelptext_(),this.isFocused_=!0}},{key:"animateBottomLine",value:function(e){var t=e.target.getBoundingClientRect(),n="transform-origin: "+({x:e.clientX,y:e.clientY}.x-t.left)+"px center";this.adapter_.setBottomLineAttr("style",n)}},{key:"autoCompleteFocus",value:function(){this.receivedUserInput_||this.activateFocus()}},{key:"showHelptext_",value:function(){var e=l.strings.ARIA_HIDDEN;this.adapter_.removeHelptextAttr(e)}},{key:"handleBottomLineAnimationEnd",value:function(e){var t=l.cssClasses.BOTTOM_LINE_ACTIVE;"opacity"!==e.propertyName||this.isFocused_||this.adapter_.removeClassFromBottomLine(t)}},{key:"deactivateFocus",value:function(){var e=l.cssClasses,t=e.FOCUSED,n=e.LABEL_FLOAT_ABOVE,i=e.LABEL_SHAKE,a=this.getNativeInput_();this.isFocused_=!1,this.adapter_.removeClass(t),this.adapter_.removeClassFromLabel(i),a.value||this.isBadInput_()||(this.adapter_.removeClassFromLabel(n),this.receivedUserInput_=!1),this.useCustomValidityChecking_||this.changeValidity_(a.checkValidity())}},{key:"changeValidity_",value:function(e){var t=l.cssClasses,n=t.INVALID,i=t.LABEL_SHAKE;e?this.adapter_.removeClass(n):(this.adapter_.addClassToLabel(i),this.adapter_.addClass(n)),this.updateHelptext_(e)}},{key:"updateHelptext_",value:function(e){var t=l.cssClasses,n=t.HELPTEXT_PERSISTENT,i=t.HELPTEXT_VALIDATION_MSG,a=l.strings.ROLE,s=this.adapter_.helptextHasClass(n),r=this.adapter_.helptextHasClass(i)&&!e;r?this.adapter_.setHelptextAttr(a,"alert"):this.adapter_.removeHelptextAttr(a),s||r||this.hideHelptext_()}},{key:"hideHelptext_",value:function(){var e=l.strings.ARIA_HIDDEN;this.adapter_.setHelptextAttr(e,"true")}},{key:"isBadInput_",value:function(){var e=this.getNativeInput_();return e.validity?e.validity.badInput:e.badInput}},{key:"isDisabled",value:function(){return this.getNativeInput_().disabled}},{key:"setDisabled",value:function(e){var t=l.cssClasses.DISABLED;this.getNativeInput_().disabled=e,e?(this.adapter_.addClass(t),this.adapter_.setIconAttr("tabindex","-1")):(this.adapter_.removeClass(t),this.adapter_.setIconAttr("tabindex","0"))}},{key:"getNativeInput_",value:function(){return this.adapter_.getNativeInput()||{checkValidity:function(){return!0},value:"",disabled:!1,badInput:!1}}},{key:"setValid",value:function(e){this.useCustomValidityChecking_=!0,this.changeValidity_(e)}}]),l}(),l=(function(){function n(){e(this,n)}t(n,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerResizeHandler",value:function(e){}},{key:"deregisterResizeHandler",value:function(e){}},{key:"updateCssVariable",value:function(e,t){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",BG_ACTIVE_FILL:"mdc-ripple-upgraded--background-active-fill",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),u={VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},d={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:300,FG_DEACTIVATION_MS:83},c=void 0,f={mouseup:"mousedown",pointerup:"pointerdown",touchend:"touchstart",keyup:"keydown",blur:"focus"},p=function(s){function r(t){e(this,r);var n=i(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,Object.assign(r.defaultAdapter,t)));return n.layoutFrame_=0,n.frame_={width:0,height:0},n.activationState_=n.defaultActivationState_(),n.xfDuration_=0,n.initialSize_=0,n.maxRadius_=0,n.listenerInfos_=[{activate:"touchstart",deactivate:"touchend"},{activate:"pointerdown",deactivate:"pointerup"},{activate:"mousedown",deactivate:"mouseup"},{activate:"keydown",deactivate:"keyup"},{focus:"focus",blur:"blur"}],n.listeners_={activate:function(e){return n.activate_(e)},deactivate:function(e){return n.deactivate_(e)},focus:function(){return requestAnimationFrame(function(){return n.adapter_.addClass(r.cssClasses.BG_FOCUSED)})},blur:function(){return requestAnimationFrame(function(){return n.adapter_.removeClass(r.cssClasses.BG_FOCUSED)})}},n.resizeHandler_=function(){return n.layout()},n.unboundedCoords_={left:0,top:0},n.fgScale_=0,n.activationTimer_=0,n.fgDeactivationRemovalTimer_=0,n.activationAnimationHasEnded_=!1,n.activationTimerCallback_=function(){n.activationAnimationHasEnded_=!0,n.runDeactivationUXLogicIfReady_()},n}return n(r,a),t(r,null,[{key:"cssClasses",get:function(){return l}},{key:"strings",get:function(){return u}},{key:"numbers",get:function(){return d}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),t(r,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationStartTime:0,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var e=this;if(this.isSupported_()){this.addEventListeners_();var t=r.cssClasses,n=t.ROOT,i=t.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.addClass(n),e.adapter_.isUnbounded()&&e.adapter_.addClass(i),e.layoutInternal_()})}}},{key:"addEventListeners_",value:function(){var e=this;this.listenerInfos_.forEach(function(t){Object.keys(t).forEach(function(n){e.adapter_.registerInteractionHandler(t[n],e.listeners_[n])})}),this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"activate_",value:function(e){var t=this;if(!this.adapter_.isSurfaceDisabled()){var n=this.activationState_;n.isActivated||(n.isActivated=!0,n.isProgrammatic=null===e,n.activationEvent=e,n.wasActivatedByPointer=!n.isProgrammatic&&("mousedown"===e.type||"touchstart"===e.type||"pointerdown"===e.type),n.activationStartTime=Date.now(),requestAnimationFrame(function(){n.wasElementMadeActive=!e||"keydown"!==e.type||t.adapter_.isSurfaceActive(),n.wasElementMadeActive?t.animateActivation_():t.activationState_=t.defaultActivationState_()}))}}},{key:"activate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(e)}},{key:"animateActivation_",value:function(){var e=this,t=r.strings,n=t.VAR_FG_TRANSLATE_START,i=t.VAR_FG_TRANSLATE_END,a=r.cssClasses,s=a.BG_ACTIVE_FILL,o=a.FG_DEACTIVATION,l=a.FG_ACTIVATION,u=r.numbers.DEACTIVATION_TIMEOUT_MS,d="",c="";if(!this.adapter_.isUnbounded()){var f=this.getFgTranslationCoordinates_(),p=f.startPoint,_=f.endPoint;d=p.x+"px, "+p.y+"px",c=_.x+"px, "+_.y+"px"}this.adapter_.updateCssVariable(n,d),this.adapter_.updateCssVariable(i,c),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(o),this.adapter_.computeBoundingRect(),this.adapter_.addClass(s),this.adapter_.addClass(l),this.activationTimer_=setTimeout(function(){return e.activationTimerCallback_()},u)}},{key:"getFgTranslationCoordinates_",value:function(){var e=this.activationState_,t=e.activationEvent,n=void 0;return{startPoint:n={x:(n=e.wasActivatedByPointer?function(e,t,n){var i=t.x,a=t.y,s=i+n.left,r=a+n.top,o=void 0,l=void 0;return"touchstart"===e.type?(o=e.changedTouches[0].pageX-s,l=e.changedTouches[0].pageY-r):(o=e.pageX-s,l=e.pageY-r),{x:o,y:l}}(t,this.adapter_.getWindowPageOffset(),this.adapter_.computeBoundingRect()):{x:this.frame_.width/2,y:this.frame_.height/2}).x-this.initialSize_/2,y:n.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var e=this,t=r.cssClasses.FG_DEACTIVATION,n=this.activationState_,i=n.hasDeactivationUXRun,a=n.isActivated;(i||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(t),this.fgDeactivationRemovalTimer_=setTimeout(function(){e.adapter_.removeClass(t)},d.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var e=r.cssClasses,t=e.BG_ACTIVE_FILL,n=e.FG_ACTIVATION;this.adapter_.removeClass(t),this.adapter_.removeClass(n),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"deactivate_",value:function(e){var t=this,n=this.activationState_;if(n.isActivated){if(n.isProgrammatic){var i=Object.assign({},n);return requestAnimationFrame(function(){return t.animateDeactivation_(null,i)}),void(this.activationState_=this.defaultActivationState_())}var a=f[e.type]===n.activationEvent.type,s=a;n.wasActivatedByPointer&&(s="mouseup"===e.type);var r=Object.assign({},n);requestAnimationFrame(function(){a&&(t.activationState_.hasDeactivationUXRun=!0,t.animateDeactivation_(e,r)),s&&(t.activationState_=t.defaultActivationState_())})}}},{key:"deactivate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(e)}},{key:"animateDeactivation_",value:function(e,t){var n=t.wasActivatedByPointer,i=t.wasElementMadeActive,a=r.cssClasses.BG_FOCUSED;(n||i)&&(this.adapter_.removeClass(a),this.runDeactivationUXLogicIfReady_())}},{key:"destroy",value:function(){var e=this;if(this.isSupported_()){this.removeEventListeners_();var t=r.cssClasses,n=t.ROOT,i=t.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.removeClass(n),e.adapter_.removeClass(i),e.removeCssVars_()})}}},{key:"removeEventListeners_",value:function(){var e=this;this.listenerInfos_.forEach(function(t){Object.keys(t).forEach(function(n){e.adapter_.deregisterInteractionHandler(t[n],e.listeners_[n])})}),this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"removeCssVars_",value:function(){var e=this,t=r.strings;Object.keys(t).forEach(function(n){0===n.indexOf("VAR_")&&e.adapter_.updateCssVariable(t[n],null)})}},{key:"layout",value:function(){var e=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){e.layoutInternal_(),e.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){this.frame_=this.adapter_.computeBoundingRect();var e=Math.max(this.frame_.height,this.frame_.width),t=Math.sqrt(Math.pow(this.frame_.width,2)+Math.pow(this.frame_.height,2));this.initialSize_=e*r.numbers.INITIAL_ORIGIN_SCALE,this.maxRadius_=t+r.numbers.PADDING,this.fgScale_=this.maxRadius_/this.initialSize_,this.xfDuration_=1e3*Math.sqrt(this.maxRadius_/1024),this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var e=r.strings,t=e.VAR_FG_SIZE,n=e.VAR_LEFT,i=e.VAR_TOP,a=e.VAR_FG_SCALE;this.adapter_.updateCssVariable(t,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(n,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(i,this.unboundedCoords_.top+"px"))}}]),r}(),_=function(a){function s(t,n){return e(this,s),i(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,Object.assign({browserSupportsCssVars:function(){return function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if("boolean"==typeof c&&!t)return c;if(e.CSS&&"function"==typeof e.CSS.supports){var n=e.CSS.supports("--css-vars","yes"),i=e.CSS.supports("(--css-vars: yes)")&&e.CSS.supports("color","#00000000");return c=!(!n&&!i||function(e){var t=e.document,n=t.createElement("div");n.className="mdc-ripple-surface--test-edge-var-bug",t.body.appendChild(n);var i=e.getComputedStyle(n),a=null!==i&&"solid"===i.borderTopStyle;return n.remove(),a}(e))}}(window)},registerResizeHandler:function(e){return window.addEventListener("resize",e)},deregisterResizeHandler:function(e){return window.removeEventListener("resize",e)},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}},isUnbounded:function(){return!1},computeBoundingRect:function(){return t.$el.getBoundingClientRect()},isSurfaceActive:function(){return t.$el[s.MATCHES](":active")},isSurfaceDisabled:function(){return t.disabled},addClass:function(e){t.$set(t.classes,e,!0)},removeClass:function(e){t.$delete(t.classes,e)},registerInteractionHandler:function(e,n){t.$el.addEventListener(e,n)},deregisterInteractionHandler:function(e,n){t.$el.removeEventListener(e,n)},updateCssVariable:function(e,n){t.$set(t.styles,e,n)}},n)))}return n(s,p),t(s,null,[{key:"isSurfaceActive",value:function(e){return e[s.MATCHES](":active")}},{key:"MATCHES",get:function(){return s._matches||(s._matches=function(e){return["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(t){return t in e}).pop()}(HTMLElement.prototype))}}]),s}(),v=function(e){var t=Object.values(e).reduce(function(e,t){return Object.assign(e,function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({},t.name,t))},{});return{install:function(e){for(var n in t)e.component(n,t[n])},components:t}}({mdcTextField:{render:function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",[e.multiline&&e.fullwidth?n("div",{ref:"root",class:e.rootClasses},[n("textarea",{ref:"input",class:e.inputClasses,attrs:{rows:e.rows,minlength:e.minlength,maxlength:e.maxlength,"aria-controls":"help-"+e._uid,placeholder:e.label,"aria-label":e.label},domProps:{value:e.value},on:{input:function(t){e.updateValue(t.target.value)}}},[e._v("      >")])]):e.multiline?n("div",{ref:"root",class:e.rootClasses},[n("textarea",{ref:"input",class:e.inputClasses,attrs:{id:e._uid,rows:e.rows,cols:e.cols,minlength:e.minlength,maxlength:e.maxlength,"aria-controls":"help-"+e._uid},domProps:{value:e.value},on:{input:function(t){e.updateValue(t.target.value)}}}),e._v(" "),e.label?n("label",{ref:"label",class:e.labelClassesUpgraded,attrs:{for:e._uid}},[e._v(" "+e._s(e.label)+" ")]):e._e()]):e.fullwidth?n("div",{ref:"root",class:e.rootClasses},[n("input",{ref:"input",class:e.inputClasses,attrs:{type:e.type,required:e.required,minlength:e.minlength,maxlength:e.maxlength,"aria-controls":"help-"+e._uid,placeholder:e.label,"aria-label":e.label},domProps:{value:e.value},on:{input:function(t){e.updateValue(t.target.value)}}})]):n("div",{ref:"root",class:e.rootClasses},[n("input",{ref:"input",class:e.inputClasses,attrs:{type:e.type,id:e._uid,required:e.required,size:e.size,minlength:e.minlength,maxlength:e.maxlength,"aria-controls":"help-"+e._uid},domProps:{value:e.value},on:{input:function(t){e.updateValue(t.target.value)}}}),e._v(" "),e.label?n("label",{ref:"label",class:e.labelClassesUpgraded,attrs:{for:e._uid}},[e._v(" "+e._s(e.label)+" ")]):e._e(),e._v(" "),n("div",{ref:"bottom",class:e.bottomClasses})]),e._v(" "),e.helptext?n("p",{ref:"help",class:e.helpClasses,attrs:{id:"help-"+e._uid,"aria-hidden":"true"}},[e._v(" "+e._s(e.helptext)+" ")]):e._e()])},staticRenderFns:[],name:"mdc-textfield",props:{value:String,type:{type:String,default:"text",validator:function(e){return["text","email","search","password","tel","url"].includes(e)}},dense:Boolean,label:String,helptext:String,"helptext-persistent":Boolean,"helptext-validation":Boolean,disabled:Boolean,required:Boolean,minlength:{type:[Number,String],default:void 0},maxlength:{type:[Number,String],default:void 0},size:{type:[Number,String],default:20},fullwidth:Boolean,multiline:Boolean,rows:{type:[Number,String],default:8},cols:{type:[Number,String],default:40}},data:function(){return{text:this.value,rootClasses:{"mdc-text-field":!0,"mdc-text-field--upgraded":!0,"mdc-text-field--disabled":this.disabled,"mdc-text-field--dense":this.dense,"mdc-text-field--fullwidth":this.fullwidth,"mdc-text-field--textarea":this.multiline},inputClasses:{"mdc-text-field__input":!0},labelClasses:{"mdc-text-field__label":!0},bottomClasses:{"mdc-text-field__bottom-line":!0},helpClasses:{"mdc-text-field-helptext":!0,"mdc-text-field-helptext--persistent":this.helptextPersistent,"mdc-text-field-helptext--validation-msg":this.helptextValidation}}},watch:{disabled:function(){this.foundation&&this.foundation.setDisabled(this.disabled)}},methods:{updateValue:function(e){this.$emit("input",e)}},computed:{labelClassesUpgraded:function(){return Object.assign(this.labelClasses,{"mdc-text-field__label--float-above":this.value})}},mounted:function(){var e=this;this.foundation=new o({addClass:function(t){e.$set(e.rootClasses,t,!0)},removeClass:function(t){e.$delete(e.rootClasses,t)},addClassToLabel:function(t){e.$set(e.labelClasses,t,!0)},removeClassFromLabel:function(t){e.$delete(e.labelClasses,t)},setIconAttr:function(){},eventTargetHasClass:function(e,t){return e.classList.contains(t)},registerTextFieldInteractionHandler:function(t,n){e.$refs.root.addEventListener(t,n)},deregisterTextFieldInteractionHandler:function(t,n){e.$refs.root.removeEventListener(t,n)},addClassToBottomLine:function(t){e.$set(e.bottomClasses,t,!0)},removeClassFromBottomLine:function(t){e.$delete(e.bottomClasses,t)},addClassToHelptext:function(t){e.$set(e.helpClasses,t,!0)},removeClassFromHelptext:function(t){e.$delete(e.helpClasses,t)},helptextHasClass:function(t){return e.$refs.help&&e.$refs.help.classList.contains(t)},registerInputInteractionHandler:function(t,n){e.$refs.input.addEventListener(t,n)},deregisterInputInteractionHandler:function(t,n){e.$refs.input.removeEventListener(t,n)},registerTransitionEndHandler:function(t){e.$refs.bottom&&e.$refs.bottom.addEventListener("transitionend",t)},deregisterTransitionEndHandler:function(t){e.$refs.bottom&&e.$refs.bottom.removeEventListener("transitionend",t)},setBottomLineAttr:function(t,n){e.$refs.bottom&&e.$refs.bottom.setAttribute(t,n)},setHelptextAttr:function(t,n){e.$refs.help&&e.$refs.help.setAttribute(t,n)},removeHelptextAttr:function(t){e.$refs.help&&e.$refs.help.removeAttribute(t)},getNativeInput:function(){return e.$refs.input},notifyIconAction:function(){e.$emit("icon")}}),this.foundation.init(),this.foundation.setDisabled(this.disabled),this.textbox&&(this.ripple=new _(this),this.ripple.init())},beforeDestroy:function(){this.foundation.destroy(),this.ripple&&this.ripple.destroy()}}});return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(v),v});
//# sourceMappingURL=index.min.js.map
